Difficulty: 🟢 Easy
Given the heads of two singly linked-lists headA
and headB
, return the node at which the two lists intersect. If the two linked lists have no intersection at all, return null
.
For example, the following two linked lists begin to intersect at node c1
:
The test cases are generated such that there are no cycles anywhere in the entire linked structure.
Note that the linked lists must retain their original structure after the function returns.
Custom Judge:
The inputs to the judge are given as follows (your program is not given these inputs):
intersectVal
- The value of the node where the intersection occurs. This is0
if there is no intersected node.listA
- The first linked list.listB
- The second linked list.skipA
- The number of nodes to skip ahead inlistA
(starting from the head) to get to the intersected node.skipB
- The number of nodes to skip ahead inlistB
(starting from the head) to get to the intersected node.
The judge will then create the linked structure based on these inputs and pass the two heads, headA
and headB
to your program. If you correctly return the intersected node, then your solution will be accepted.
Example 1:
Input: intersectVal = 8, listA = [4,1,8,4,5], listB = [5,6,1,8,4,5], skipA = 2, skipB = 3
Output: Intersected at '8'
Explanation: The intersected node's value is 8 (note that this must not be 0 if the two lists intersect).
From the head of A, it reads as [4,1,8,4,5]. From the head of B, it reads as [5,6,1,8,4,5]. There are 2 nodes before the intersected node in A; There are 3 nodes before the intersected node in B.
- Note that the intersected node's value is not 1 because the nodes with value 1 in A and B (2nd node in A and 3rd node in B) are different node references. In other words, they point to two different locations in memory, while the nodes with value 8 in A and B (3rd node in A and 4th node in B) point to the same location in memory.
Example 2:
Input: intersectVal = 2, listA = [1,9,1,2,4], listB = [3,2,4], skipA = 3, skipB = 1
Output: Intersected at '2'
Explanation: The intersected node's value is 2 (note that this must not be 0 if the two lists intersect).
From the head of A, it reads as [1,9,1,2,4]. From the head of B, it reads as [3,2,4]. There are 3 nodes before the intersected node in A; There are 1 node before the intersected node in B.
Example 3:
Input: intersectVal = 0, listA = [2,6,4], listB = [1,5], skipA = 3, skipB = 2
Output: No intersection
Explanation: From the head of A, it reads as [2,6,4]. From the head of B, it reads as [1,5]. Since the two lists do not intersect, intersectVal must be 0, while skipA and skipB can be arbitrary values.
Explanation: The two lists do not intersect, so return null.
- The number of nodes of
listA
is in them
. - The number of nodes of
listB
is in then
. 1 <= m, n <= 3 * 104
1 <= Node.val <= 105
0 <= skipA < m
0 <= skipB < n
intersectVal
is0
iflistA
andlistB
do not intersect.intersectVal == listA[skipA] == listB[skipB]
iflistA
andlistB
intersect.
Could you write a solution that runs in O(m + n)
time and use only O(1)
memory?
# Definition for singly-linked list.
# class ListNode:
# def __init__(self, x):
# self.val = x
# self.next = None
class Solution:
def getIntersectionNode(self, headA: ListNode, headB: ListNode) -> Optional[ListNode]:
pointer_one = headA
pointer_two = headB
while pointer_one != pointer_two:
pointer_one = pointer_one.next if pointer_one else headB
pointer_two = pointer_two.next if pointer_two else headA
return pointer_one
The given solution solves the problem using a two-pointer approach. We maintain two pointers, pointer_one
and pointer_two
, initialized to headA
and headB
, respectively. We iterate over the linked lists by moving both pointers forward one step at a time. When either pointer reaches the end of its respective linked list, we reset it to the head of the other linked list. We continue this process until both pointers meet at the intersection point or reach the end of the linked lists.
The algorithm follows these steps:
- Initialize
pointer_one
toheadA
andpointer_two
toheadB
. - Iterate while
pointer_one
is not equal topointer_two
:- If
pointer_one
is notNone
, move it one step forward (pointer_one = pointer_one.next
). - If
pointer_one
isNone
, reset it toheadB
. - If
pointer_two
is notNone
, move it one step forward (pointer_two = pointer_two.next
). - If
pointer_two
isNone
, reset it toheadA
.
- If
- Return
pointer_one
, which is the node at which the two linked lists intersect.
The time complexity of the algorithm is O(m + n) because in the worst case, we need to traverse both linked lists to find the intersection point.
The space complexity of the algorithm is O(1) because it uses a constant amount of additional space to store the two pointers.
The given solution finds the node at which two singly linked lists headA
and headB
intersect. It uses a two-pointer approach to iterate over the linked lists, resetting the pointers to the heads of the other linked lists when they reach the end. The algorithm has a time complexity of O(m + n) and a space complexity of O(1).
NB: If you want to get community points please suggest solutions in other languages as merge requests.